# Events ## List events `client.waitingRooms.events.list(stringwaitingRoomId, EventListParamsparams, RequestOptionsoptions?): V4PagePaginationArray` **get** `/zones/{zone_id}/waiting_rooms/{waiting_room_id}/events` Lists events for a waiting room. ### Parameters - `waitingRoomId: string` - `params: EventListParams` - `zone_id: string` Path param: Identifier. - `page?: number` Query param: Page number of paginated results. - `per_page?: number` Query param: Maximum number of results per page. Must be a multiple of 5. ### Returns - `Event` - `id?: string` - `created_on?: string` - `custom_page_html?: string | null` If set, the event will override the waiting room's `custom_page_html` property while it is active. If null, the event will inherit it. - `description?: string` A note that you can use to add more details about the event. - `disable_session_renewal?: boolean | null` If set, the event will override the waiting room's `disable_session_renewal` property while it is active. If null, the event will inherit it. - `event_end_time?: string` An ISO 8601 timestamp that marks the end of the event. - `event_start_time?: string` An ISO 8601 timestamp that marks the start of the event. At this time, queued users will be processed with the event's configuration. The start time must be at least one minute before `event_end_time`. - `modified_on?: string` - `name?: string` A unique name to identify the event. Only alphanumeric characters, hyphens and underscores are allowed. - `new_users_per_minute?: number | null` If set, the event will override the waiting room's `new_users_per_minute` property while it is active. If null, the event will inherit it. This can only be set if the event's `total_active_users` property is also set. - `prequeue_start_time?: string | null` An ISO 8601 timestamp that marks when to begin queueing all users before the event starts. The prequeue must start at least five minutes before `event_start_time`. - `queueing_method?: string | null` If set, the event will override the waiting room's `queueing_method` property while it is active. If null, the event will inherit it. - `session_duration?: number | null` If set, the event will override the waiting room's `session_duration` property while it is active. If null, the event will inherit it. - `shuffle_at_event_start?: boolean` If enabled, users in the prequeue will be shuffled randomly at the `event_start_time`. Requires that `prequeue_start_time` is not null. This is useful for situations when many users will join the event prequeue at the same time and you want to shuffle them to ensure fairness. Naturally, it makes the most sense to enable this feature when the `queueing_method` during the event respects ordering such as **fifo**, or else the shuffling may be unnecessary. - `suspended?: boolean` Suspends or allows an event. If set to `true`, the event is ignored and traffic will be handled based on the waiting room configuration. - `total_active_users?: number | null` If set, the event will override the waiting room's `total_active_users` property while it is active. If null, the event will inherit it. This can only be set if the event's `new_users_per_minute` property is also set. - `turnstile_action?: "log" | "infinite_queue" | null` If set, the event will override the waiting room's `turnstile_action` property while it is active. If null, the event will inherit it. - `"log"` - `"infinite_queue"` - `turnstile_mode?: "off" | "invisible" | "visible_non_interactive" | "visible_managed" | null` If set, the event will override the waiting room's `turnstile_mode` property while it is active. If null, the event will inherit it. - `"off"` - `"invisible"` - `"visible_non_interactive"` - `"visible_managed"` ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); // Automatically fetches more pages as needed. for await (const event of client.waitingRooms.events.list('699d98642c564d2e855e9661899b7252', { zone_id: '023e105f4ecef8ad9ca31a8372d0c353', })) { console.log(event.id); } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": [ { "id": "25756b2dfe6e378a06b033b670413757", "created_on": "2014-01-01T05:20:00.12345Z", "custom_page_html": "{{#waitTimeKnown}} {{waitTime}} mins {{/waitTimeKnown}} {{^waitTimeKnown}} Event is prequeueing / Queue all enabled {{/waitTimeKnown}}", "description": "Production event - DO NOT MODIFY", "disable_session_renewal": true, "event_end_time": "2021-09-28T17:00:00.000Z", "event_start_time": "2021-09-28T15:30:00.000Z", "modified_on": "2014-01-01T05:20:00.12345Z", "name": "production_webinar_event", "new_users_per_minute": 200, "prequeue_start_time": "2021-09-28T15:00:00.000Z", "queueing_method": "random", "session_duration": 1, "shuffle_at_event_start": true, "suspended": true, "total_active_users": 200, "turnstile_action": "log", "turnstile_mode": "off" } ], "result_info": { "count": 1, "page": 1, "per_page": 20, "total_count": 2000 } } ``` ## Event details `client.waitingRooms.events.get(stringwaitingRoomId, stringeventId, EventGetParamsparams, RequestOptionsoptions?): Event` **get** `/zones/{zone_id}/waiting_rooms/{waiting_room_id}/events/{event_id}` Fetches a single configured event for a waiting room. ### Parameters - `waitingRoomId: string` - `eventId: string` - `params: EventGetParams` - `zone_id: string` Identifier. ### Returns - `Event` - `id?: string` - `created_on?: string` - `custom_page_html?: string | null` If set, the event will override the waiting room's `custom_page_html` property while it is active. If null, the event will inherit it. - `description?: string` A note that you can use to add more details about the event. - `disable_session_renewal?: boolean | null` If set, the event will override the waiting room's `disable_session_renewal` property while it is active. If null, the event will inherit it. - `event_end_time?: string` An ISO 8601 timestamp that marks the end of the event. - `event_start_time?: string` An ISO 8601 timestamp that marks the start of the event. At this time, queued users will be processed with the event's configuration. The start time must be at least one minute before `event_end_time`. - `modified_on?: string` - `name?: string` A unique name to identify the event. Only alphanumeric characters, hyphens and underscores are allowed. - `new_users_per_minute?: number | null` If set, the event will override the waiting room's `new_users_per_minute` property while it is active. If null, the event will inherit it. This can only be set if the event's `total_active_users` property is also set. - `prequeue_start_time?: string | null` An ISO 8601 timestamp that marks when to begin queueing all users before the event starts. The prequeue must start at least five minutes before `event_start_time`. - `queueing_method?: string | null` If set, the event will override the waiting room's `queueing_method` property while it is active. If null, the event will inherit it. - `session_duration?: number | null` If set, the event will override the waiting room's `session_duration` property while it is active. If null, the event will inherit it. - `shuffle_at_event_start?: boolean` If enabled, users in the prequeue will be shuffled randomly at the `event_start_time`. Requires that `prequeue_start_time` is not null. This is useful for situations when many users will join the event prequeue at the same time and you want to shuffle them to ensure fairness. Naturally, it makes the most sense to enable this feature when the `queueing_method` during the event respects ordering such as **fifo**, or else the shuffling may be unnecessary. - `suspended?: boolean` Suspends or allows an event. If set to `true`, the event is ignored and traffic will be handled based on the waiting room configuration. - `total_active_users?: number | null` If set, the event will override the waiting room's `total_active_users` property while it is active. If null, the event will inherit it. This can only be set if the event's `new_users_per_minute` property is also set. - `turnstile_action?: "log" | "infinite_queue" | null` If set, the event will override the waiting room's `turnstile_action` property while it is active. If null, the event will inherit it. - `"log"` - `"infinite_queue"` - `turnstile_mode?: "off" | "invisible" | "visible_non_interactive" | "visible_managed" | null` If set, the event will override the waiting room's `turnstile_mode` property while it is active. If null, the event will inherit it. - `"off"` - `"invisible"` - `"visible_non_interactive"` - `"visible_managed"` ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const event = await client.waitingRooms.events.get( '699d98642c564d2e855e9661899b7252', '25756b2dfe6e378a06b033b670413757', { zone_id: '023e105f4ecef8ad9ca31a8372d0c353' }, ); console.log(event.id); ``` #### Response ```json { "result": { "id": "25756b2dfe6e378a06b033b670413757", "created_on": "2014-01-01T05:20:00.12345Z", "custom_page_html": "{{#waitTimeKnown}} {{waitTime}} mins {{/waitTimeKnown}} {{^waitTimeKnown}} Event is prequeueing / Queue all enabled {{/waitTimeKnown}}", "description": "Production event - DO NOT MODIFY", "disable_session_renewal": true, "event_end_time": "2021-09-28T17:00:00.000Z", "event_start_time": "2021-09-28T15:30:00.000Z", "modified_on": "2014-01-01T05:20:00.12345Z", "name": "production_webinar_event", "new_users_per_minute": 200, "prequeue_start_time": "2021-09-28T15:00:00.000Z", "queueing_method": "random", "session_duration": 1, "shuffle_at_event_start": true, "suspended": true, "total_active_users": 200, "turnstile_action": "log", "turnstile_mode": "off" } } ``` ## Create event `client.waitingRooms.events.create(stringwaitingRoomId, EventCreateParamsparams, RequestOptionsoptions?): Event` **post** `/zones/{zone_id}/waiting_rooms/{waiting_room_id}/events` Only available for the Waiting Room Advanced subscription. Creates an event for a waiting room. An event takes place during a specified period of time, temporarily changing the behavior of a waiting room. While the event is active, some of the properties in the event's configuration may either override or inherit from the waiting room's configuration. Note that events cannot overlap with each other, so only one event can be active at a time. ### Parameters - `waitingRoomId: string` - `params: EventCreateParams` - `zone_id: string` Path param: Identifier. - `event_end_time: string` Body param: An ISO 8601 timestamp that marks the end of the event. - `event_start_time: string` Body param: An ISO 8601 timestamp that marks the start of the event. At this time, queued users will be processed with the event's configuration. The start time must be at least one minute before `event_end_time`. - `name: string` Body param: A unique name to identify the event. Only alphanumeric characters, hyphens and underscores are allowed. - `custom_page_html?: string | null` Body param: If set, the event will override the waiting room's `custom_page_html` property while it is active. If null, the event will inherit it. - `description?: string` Body param: A note that you can use to add more details about the event. - `disable_session_renewal?: boolean | null` Body param: If set, the event will override the waiting room's `disable_session_renewal` property while it is active. If null, the event will inherit it. - `new_users_per_minute?: number | null` Body param: If set, the event will override the waiting room's `new_users_per_minute` property while it is active. If null, the event will inherit it. This can only be set if the event's `total_active_users` property is also set. - `prequeue_start_time?: string | null` Body param: An ISO 8601 timestamp that marks when to begin queueing all users before the event starts. The prequeue must start at least five minutes before `event_start_time`. - `queueing_method?: string | null` Body param: If set, the event will override the waiting room's `queueing_method` property while it is active. If null, the event will inherit it. - `session_duration?: number | null` Body param: If set, the event will override the waiting room's `session_duration` property while it is active. If null, the event will inherit it. - `shuffle_at_event_start?: boolean` Body param: If enabled, users in the prequeue will be shuffled randomly at the `event_start_time`. Requires that `prequeue_start_time` is not null. This is useful for situations when many users will join the event prequeue at the same time and you want to shuffle them to ensure fairness. Naturally, it makes the most sense to enable this feature when the `queueing_method` during the event respects ordering such as **fifo**, or else the shuffling may be unnecessary. - `suspended?: boolean` Body param: Suspends or allows an event. If set to `true`, the event is ignored and traffic will be handled based on the waiting room configuration. - `total_active_users?: number | null` Body param: If set, the event will override the waiting room's `total_active_users` property while it is active. If null, the event will inherit it. This can only be set if the event's `new_users_per_minute` property is also set. - `turnstile_action?: "log" | "infinite_queue" | null` Body param: If set, the event will override the waiting room's `turnstile_action` property while it is active. If null, the event will inherit it. - `"log"` - `"infinite_queue"` - `turnstile_mode?: "off" | "invisible" | "visible_non_interactive" | "visible_managed" | null` Body param: If set, the event will override the waiting room's `turnstile_mode` property while it is active. If null, the event will inherit it. - `"off"` - `"invisible"` - `"visible_non_interactive"` - `"visible_managed"` ### Returns - `Event` - `id?: string` - `created_on?: string` - `custom_page_html?: string | null` If set, the event will override the waiting room's `custom_page_html` property while it is active. If null, the event will inherit it. - `description?: string` A note that you can use to add more details about the event. - `disable_session_renewal?: boolean | null` If set, the event will override the waiting room's `disable_session_renewal` property while it is active. If null, the event will inherit it. - `event_end_time?: string` An ISO 8601 timestamp that marks the end of the event. - `event_start_time?: string` An ISO 8601 timestamp that marks the start of the event. At this time, queued users will be processed with the event's configuration. The start time must be at least one minute before `event_end_time`. - `modified_on?: string` - `name?: string` A unique name to identify the event. Only alphanumeric characters, hyphens and underscores are allowed. - `new_users_per_minute?: number | null` If set, the event will override the waiting room's `new_users_per_minute` property while it is active. If null, the event will inherit it. This can only be set if the event's `total_active_users` property is also set. - `prequeue_start_time?: string | null` An ISO 8601 timestamp that marks when to begin queueing all users before the event starts. The prequeue must start at least five minutes before `event_start_time`. - `queueing_method?: string | null` If set, the event will override the waiting room's `queueing_method` property while it is active. If null, the event will inherit it. - `session_duration?: number | null` If set, the event will override the waiting room's `session_duration` property while it is active. If null, the event will inherit it. - `shuffle_at_event_start?: boolean` If enabled, users in the prequeue will be shuffled randomly at the `event_start_time`. Requires that `prequeue_start_time` is not null. This is useful for situations when many users will join the event prequeue at the same time and you want to shuffle them to ensure fairness. Naturally, it makes the most sense to enable this feature when the `queueing_method` during the event respects ordering such as **fifo**, or else the shuffling may be unnecessary. - `suspended?: boolean` Suspends or allows an event. If set to `true`, the event is ignored and traffic will be handled based on the waiting room configuration. - `total_active_users?: number | null` If set, the event will override the waiting room's `total_active_users` property while it is active. If null, the event will inherit it. This can only be set if the event's `new_users_per_minute` property is also set. - `turnstile_action?: "log" | "infinite_queue" | null` If set, the event will override the waiting room's `turnstile_action` property while it is active. If null, the event will inherit it. - `"log"` - `"infinite_queue"` - `turnstile_mode?: "off" | "invisible" | "visible_non_interactive" | "visible_managed" | null` If set, the event will override the waiting room's `turnstile_mode` property while it is active. If null, the event will inherit it. - `"off"` - `"invisible"` - `"visible_non_interactive"` - `"visible_managed"` ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const event = await client.waitingRooms.events.create('699d98642c564d2e855e9661899b7252', { zone_id: '023e105f4ecef8ad9ca31a8372d0c353', event_end_time: '2021-09-28T17:00:00.000Z', event_start_time: '2021-09-28T15:30:00.000Z', name: 'production_webinar_event', }); console.log(event.id); ``` #### Response ```json { "result": { "id": "25756b2dfe6e378a06b033b670413757", "created_on": "2014-01-01T05:20:00.12345Z", "custom_page_html": "{{#waitTimeKnown}} {{waitTime}} mins {{/waitTimeKnown}} {{^waitTimeKnown}} Event is prequeueing / Queue all enabled {{/waitTimeKnown}}", "description": "Production event - DO NOT MODIFY", "disable_session_renewal": true, "event_end_time": "2021-09-28T17:00:00.000Z", "event_start_time": "2021-09-28T15:30:00.000Z", "modified_on": "2014-01-01T05:20:00.12345Z", "name": "production_webinar_event", "new_users_per_minute": 200, "prequeue_start_time": "2021-09-28T15:00:00.000Z", "queueing_method": "random", "session_duration": 1, "shuffle_at_event_start": true, "suspended": true, "total_active_users": 200, "turnstile_action": "log", "turnstile_mode": "off" } } ``` ## Update event `client.waitingRooms.events.update(stringwaitingRoomId, stringeventId, EventUpdateParamsparams, RequestOptionsoptions?): Event` **put** `/zones/{zone_id}/waiting_rooms/{waiting_room_id}/events/{event_id}` Updates a configured event for a waiting room. ### Parameters - `waitingRoomId: string` - `eventId: string` - `params: EventUpdateParams` - `zone_id: string` Path param: Identifier. - `event_end_time: string` Body param: An ISO 8601 timestamp that marks the end of the event. - `event_start_time: string` Body param: An ISO 8601 timestamp that marks the start of the event. At this time, queued users will be processed with the event's configuration. The start time must be at least one minute before `event_end_time`. - `name: string` Body param: A unique name to identify the event. Only alphanumeric characters, hyphens and underscores are allowed. - `custom_page_html?: string | null` Body param: If set, the event will override the waiting room's `custom_page_html` property while it is active. If null, the event will inherit it. - `description?: string` Body param: A note that you can use to add more details about the event. - `disable_session_renewal?: boolean | null` Body param: If set, the event will override the waiting room's `disable_session_renewal` property while it is active. If null, the event will inherit it. - `new_users_per_minute?: number | null` Body param: If set, the event will override the waiting room's `new_users_per_minute` property while it is active. If null, the event will inherit it. This can only be set if the event's `total_active_users` property is also set. - `prequeue_start_time?: string | null` Body param: An ISO 8601 timestamp that marks when to begin queueing all users before the event starts. The prequeue must start at least five minutes before `event_start_time`. - `queueing_method?: string | null` Body param: If set, the event will override the waiting room's `queueing_method` property while it is active. If null, the event will inherit it. - `session_duration?: number | null` Body param: If set, the event will override the waiting room's `session_duration` property while it is active. If null, the event will inherit it. - `shuffle_at_event_start?: boolean` Body param: If enabled, users in the prequeue will be shuffled randomly at the `event_start_time`. Requires that `prequeue_start_time` is not null. This is useful for situations when many users will join the event prequeue at the same time and you want to shuffle them to ensure fairness. Naturally, it makes the most sense to enable this feature when the `queueing_method` during the event respects ordering such as **fifo**, or else the shuffling may be unnecessary. - `suspended?: boolean` Body param: Suspends or allows an event. If set to `true`, the event is ignored and traffic will be handled based on the waiting room configuration. - `total_active_users?: number | null` Body param: If set, the event will override the waiting room's `total_active_users` property while it is active. If null, the event will inherit it. This can only be set if the event's `new_users_per_minute` property is also set. - `turnstile_action?: "log" | "infinite_queue" | null` Body param: If set, the event will override the waiting room's `turnstile_action` property while it is active. If null, the event will inherit it. - `"log"` - `"infinite_queue"` - `turnstile_mode?: "off" | "invisible" | "visible_non_interactive" | "visible_managed" | null` Body param: If set, the event will override the waiting room's `turnstile_mode` property while it is active. If null, the event will inherit it. - `"off"` - `"invisible"` - `"visible_non_interactive"` - `"visible_managed"` ### Returns - `Event` - `id?: string` - `created_on?: string` - `custom_page_html?: string | null` If set, the event will override the waiting room's `custom_page_html` property while it is active. If null, the event will inherit it. - `description?: string` A note that you can use to add more details about the event. - `disable_session_renewal?: boolean | null` If set, the event will override the waiting room's `disable_session_renewal` property while it is active. If null, the event will inherit it. - `event_end_time?: string` An ISO 8601 timestamp that marks the end of the event. - `event_start_time?: string` An ISO 8601 timestamp that marks the start of the event. At this time, queued users will be processed with the event's configuration. The start time must be at least one minute before `event_end_time`. - `modified_on?: string` - `name?: string` A unique name to identify the event. Only alphanumeric characters, hyphens and underscores are allowed. - `new_users_per_minute?: number | null` If set, the event will override the waiting room's `new_users_per_minute` property while it is active. If null, the event will inherit it. This can only be set if the event's `total_active_users` property is also set. - `prequeue_start_time?: string | null` An ISO 8601 timestamp that marks when to begin queueing all users before the event starts. The prequeue must start at least five minutes before `event_start_time`. - `queueing_method?: string | null` If set, the event will override the waiting room's `queueing_method` property while it is active. If null, the event will inherit it. - `session_duration?: number | null` If set, the event will override the waiting room's `session_duration` property while it is active. If null, the event will inherit it. - `shuffle_at_event_start?: boolean` If enabled, users in the prequeue will be shuffled randomly at the `event_start_time`. Requires that `prequeue_start_time` is not null. This is useful for situations when many users will join the event prequeue at the same time and you want to shuffle them to ensure fairness. Naturally, it makes the most sense to enable this feature when the `queueing_method` during the event respects ordering such as **fifo**, or else the shuffling may be unnecessary. - `suspended?: boolean` Suspends or allows an event. If set to `true`, the event is ignored and traffic will be handled based on the waiting room configuration. - `total_active_users?: number | null` If set, the event will override the waiting room's `total_active_users` property while it is active. If null, the event will inherit it. This can only be set if the event's `new_users_per_minute` property is also set. - `turnstile_action?: "log" | "infinite_queue" | null` If set, the event will override the waiting room's `turnstile_action` property while it is active. If null, the event will inherit it. - `"log"` - `"infinite_queue"` - `turnstile_mode?: "off" | "invisible" | "visible_non_interactive" | "visible_managed" | null` If set, the event will override the waiting room's `turnstile_mode` property while it is active. If null, the event will inherit it. - `"off"` - `"invisible"` - `"visible_non_interactive"` - `"visible_managed"` ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const event = await client.waitingRooms.events.update( '699d98642c564d2e855e9661899b7252', '25756b2dfe6e378a06b033b670413757', { zone_id: '023e105f4ecef8ad9ca31a8372d0c353', event_end_time: '2021-09-28T17:00:00.000Z', event_start_time: '2021-09-28T15:30:00.000Z', name: 'production_webinar_event', }, ); console.log(event.id); ``` #### Response ```json { "result": { "id": "25756b2dfe6e378a06b033b670413757", "created_on": "2014-01-01T05:20:00.12345Z", "custom_page_html": "{{#waitTimeKnown}} {{waitTime}} mins {{/waitTimeKnown}} {{^waitTimeKnown}} Event is prequeueing / Queue all enabled {{/waitTimeKnown}}", "description": "Production event - DO NOT MODIFY", "disable_session_renewal": true, "event_end_time": "2021-09-28T17:00:00.000Z", "event_start_time": "2021-09-28T15:30:00.000Z", "modified_on": "2014-01-01T05:20:00.12345Z", "name": "production_webinar_event", "new_users_per_minute": 200, "prequeue_start_time": "2021-09-28T15:00:00.000Z", "queueing_method": "random", "session_duration": 1, "shuffle_at_event_start": true, "suspended": true, "total_active_users": 200, "turnstile_action": "log", "turnstile_mode": "off" } } ``` ## Patch event `client.waitingRooms.events.edit(stringwaitingRoomId, stringeventId, EventEditParamsparams, RequestOptionsoptions?): Event` **patch** `/zones/{zone_id}/waiting_rooms/{waiting_room_id}/events/{event_id}` Patches a configured event for a waiting room. ### Parameters - `waitingRoomId: string` - `eventId: string` - `params: EventEditParams` - `zone_id: string` Path param: Identifier. - `event_end_time: string` Body param: An ISO 8601 timestamp that marks the end of the event. - `event_start_time: string` Body param: An ISO 8601 timestamp that marks the start of the event. At this time, queued users will be processed with the event's configuration. The start time must be at least one minute before `event_end_time`. - `name: string` Body param: A unique name to identify the event. Only alphanumeric characters, hyphens and underscores are allowed. - `custom_page_html?: string | null` Body param: If set, the event will override the waiting room's `custom_page_html` property while it is active. If null, the event will inherit it. - `description?: string` Body param: A note that you can use to add more details about the event. - `disable_session_renewal?: boolean | null` Body param: If set, the event will override the waiting room's `disable_session_renewal` property while it is active. If null, the event will inherit it. - `new_users_per_minute?: number | null` Body param: If set, the event will override the waiting room's `new_users_per_minute` property while it is active. If null, the event will inherit it. This can only be set if the event's `total_active_users` property is also set. - `prequeue_start_time?: string | null` Body param: An ISO 8601 timestamp that marks when to begin queueing all users before the event starts. The prequeue must start at least five minutes before `event_start_time`. - `queueing_method?: string | null` Body param: If set, the event will override the waiting room's `queueing_method` property while it is active. If null, the event will inherit it. - `session_duration?: number | null` Body param: If set, the event will override the waiting room's `session_duration` property while it is active. If null, the event will inherit it. - `shuffle_at_event_start?: boolean` Body param: If enabled, users in the prequeue will be shuffled randomly at the `event_start_time`. Requires that `prequeue_start_time` is not null. This is useful for situations when many users will join the event prequeue at the same time and you want to shuffle them to ensure fairness. Naturally, it makes the most sense to enable this feature when the `queueing_method` during the event respects ordering such as **fifo**, or else the shuffling may be unnecessary. - `suspended?: boolean` Body param: Suspends or allows an event. If set to `true`, the event is ignored and traffic will be handled based on the waiting room configuration. - `total_active_users?: number | null` Body param: If set, the event will override the waiting room's `total_active_users` property while it is active. If null, the event will inherit it. This can only be set if the event's `new_users_per_minute` property is also set. - `turnstile_action?: "log" | "infinite_queue" | null` Body param: If set, the event will override the waiting room's `turnstile_action` property while it is active. If null, the event will inherit it. - `"log"` - `"infinite_queue"` - `turnstile_mode?: "off" | "invisible" | "visible_non_interactive" | "visible_managed" | null` Body param: If set, the event will override the waiting room's `turnstile_mode` property while it is active. If null, the event will inherit it. - `"off"` - `"invisible"` - `"visible_non_interactive"` - `"visible_managed"` ### Returns - `Event` - `id?: string` - `created_on?: string` - `custom_page_html?: string | null` If set, the event will override the waiting room's `custom_page_html` property while it is active. If null, the event will inherit it. - `description?: string` A note that you can use to add more details about the event. - `disable_session_renewal?: boolean | null` If set, the event will override the waiting room's `disable_session_renewal` property while it is active. If null, the event will inherit it. - `event_end_time?: string` An ISO 8601 timestamp that marks the end of the event. - `event_start_time?: string` An ISO 8601 timestamp that marks the start of the event. At this time, queued users will be processed with the event's configuration. The start time must be at least one minute before `event_end_time`. - `modified_on?: string` - `name?: string` A unique name to identify the event. Only alphanumeric characters, hyphens and underscores are allowed. - `new_users_per_minute?: number | null` If set, the event will override the waiting room's `new_users_per_minute` property while it is active. If null, the event will inherit it. This can only be set if the event's `total_active_users` property is also set. - `prequeue_start_time?: string | null` An ISO 8601 timestamp that marks when to begin queueing all users before the event starts. The prequeue must start at least five minutes before `event_start_time`. - `queueing_method?: string | null` If set, the event will override the waiting room's `queueing_method` property while it is active. If null, the event will inherit it. - `session_duration?: number | null` If set, the event will override the waiting room's `session_duration` property while it is active. If null, the event will inherit it. - `shuffle_at_event_start?: boolean` If enabled, users in the prequeue will be shuffled randomly at the `event_start_time`. Requires that `prequeue_start_time` is not null. This is useful for situations when many users will join the event prequeue at the same time and you want to shuffle them to ensure fairness. Naturally, it makes the most sense to enable this feature when the `queueing_method` during the event respects ordering such as **fifo**, or else the shuffling may be unnecessary. - `suspended?: boolean` Suspends or allows an event. If set to `true`, the event is ignored and traffic will be handled based on the waiting room configuration. - `total_active_users?: number | null` If set, the event will override the waiting room's `total_active_users` property while it is active. If null, the event will inherit it. This can only be set if the event's `new_users_per_minute` property is also set. - `turnstile_action?: "log" | "infinite_queue" | null` If set, the event will override the waiting room's `turnstile_action` property while it is active. If null, the event will inherit it. - `"log"` - `"infinite_queue"` - `turnstile_mode?: "off" | "invisible" | "visible_non_interactive" | "visible_managed" | null` If set, the event will override the waiting room's `turnstile_mode` property while it is active. If null, the event will inherit it. - `"off"` - `"invisible"` - `"visible_non_interactive"` - `"visible_managed"` ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const event = await client.waitingRooms.events.edit( '699d98642c564d2e855e9661899b7252', '25756b2dfe6e378a06b033b670413757', { zone_id: '023e105f4ecef8ad9ca31a8372d0c353', event_end_time: '2021-09-28T17:00:00.000Z', event_start_time: '2021-09-28T15:30:00.000Z', name: 'production_webinar_event', }, ); console.log(event.id); ``` #### Response ```json { "result": { "id": "25756b2dfe6e378a06b033b670413757", "created_on": "2014-01-01T05:20:00.12345Z", "custom_page_html": "{{#waitTimeKnown}} {{waitTime}} mins {{/waitTimeKnown}} {{^waitTimeKnown}} Event is prequeueing / Queue all enabled {{/waitTimeKnown}}", "description": "Production event - DO NOT MODIFY", "disable_session_renewal": true, "event_end_time": "2021-09-28T17:00:00.000Z", "event_start_time": "2021-09-28T15:30:00.000Z", "modified_on": "2014-01-01T05:20:00.12345Z", "name": "production_webinar_event", "new_users_per_minute": 200, "prequeue_start_time": "2021-09-28T15:00:00.000Z", "queueing_method": "random", "session_duration": 1, "shuffle_at_event_start": true, "suspended": true, "total_active_users": 200, "turnstile_action": "log", "turnstile_mode": "off" } } ``` ## Delete event `client.waitingRooms.events.delete(stringwaitingRoomId, stringeventId, EventDeleteParamsparams, RequestOptionsoptions?): EventDeleteResponse` **delete** `/zones/{zone_id}/waiting_rooms/{waiting_room_id}/events/{event_id}` Deletes an event for a waiting room. ### Parameters - `waitingRoomId: string` - `eventId: string` - `params: EventDeleteParams` - `zone_id: string` Identifier. ### Returns - `EventDeleteResponse` - `id?: string` ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const event = await client.waitingRooms.events.delete( '699d98642c564d2e855e9661899b7252', '25756b2dfe6e378a06b033b670413757', { zone_id: '023e105f4ecef8ad9ca31a8372d0c353' }, ); console.log(event.id); ``` #### Response ```json { "result": { "id": "25756b2dfe6e378a06b033b670413757" } } ``` ## Domain Types ### Event - `Event` - `id?: string` - `created_on?: string` - `custom_page_html?: string | null` If set, the event will override the waiting room's `custom_page_html` property while it is active. If null, the event will inherit it. - `description?: string` A note that you can use to add more details about the event. - `disable_session_renewal?: boolean | null` If set, the event will override the waiting room's `disable_session_renewal` property while it is active. If null, the event will inherit it. - `event_end_time?: string` An ISO 8601 timestamp that marks the end of the event. - `event_start_time?: string` An ISO 8601 timestamp that marks the start of the event. At this time, queued users will be processed with the event's configuration. The start time must be at least one minute before `event_end_time`. - `modified_on?: string` - `name?: string` A unique name to identify the event. Only alphanumeric characters, hyphens and underscores are allowed. - `new_users_per_minute?: number | null` If set, the event will override the waiting room's `new_users_per_minute` property while it is active. If null, the event will inherit it. This can only be set if the event's `total_active_users` property is also set. - `prequeue_start_time?: string | null` An ISO 8601 timestamp that marks when to begin queueing all users before the event starts. The prequeue must start at least five minutes before `event_start_time`. - `queueing_method?: string | null` If set, the event will override the waiting room's `queueing_method` property while it is active. If null, the event will inherit it. - `session_duration?: number | null` If set, the event will override the waiting room's `session_duration` property while it is active. If null, the event will inherit it. - `shuffle_at_event_start?: boolean` If enabled, users in the prequeue will be shuffled randomly at the `event_start_time`. Requires that `prequeue_start_time` is not null. This is useful for situations when many users will join the event prequeue at the same time and you want to shuffle them to ensure fairness. Naturally, it makes the most sense to enable this feature when the `queueing_method` during the event respects ordering such as **fifo**, or else the shuffling may be unnecessary. - `suspended?: boolean` Suspends or allows an event. If set to `true`, the event is ignored and traffic will be handled based on the waiting room configuration. - `total_active_users?: number | null` If set, the event will override the waiting room's `total_active_users` property while it is active. If null, the event will inherit it. This can only be set if the event's `new_users_per_minute` property is also set. - `turnstile_action?: "log" | "infinite_queue" | null` If set, the event will override the waiting room's `turnstile_action` property while it is active. If null, the event will inherit it. - `"log"` - `"infinite_queue"` - `turnstile_mode?: "off" | "invisible" | "visible_non_interactive" | "visible_managed" | null` If set, the event will override the waiting room's `turnstile_mode` property while it is active. If null, the event will inherit it. - `"off"` - `"invisible"` - `"visible_non_interactive"` - `"visible_managed"` ### Event Delete Response - `EventDeleteResponse` - `id?: string` # Details ## Preview active event details `client.waitingRooms.events.details.get(stringwaitingRoomId, stringeventId, DetailGetParamsparams, RequestOptionsoptions?): DetailGetResponse` **get** `/zones/{zone_id}/waiting_rooms/{waiting_room_id}/events/{event_id}/details` Previews an event's configuration as if it was active. Inherited fields from the waiting room will be displayed with their current values. ### Parameters - `waitingRoomId: string` - `eventId: string` - `params: DetailGetParams` - `zone_id: string` Identifier. ### Returns - `DetailGetResponse` - `id?: string` - `created_on?: string` - `custom_page_html?: string` - `description?: string` A note that you can use to add more details about the event. - `disable_session_renewal?: boolean` - `event_end_time?: string` An ISO 8601 timestamp that marks the end of the event. - `event_start_time?: string` An ISO 8601 timestamp that marks the start of the event. At this time, queued users will be processed with the event's configuration. The start time must be at least one minute before `event_end_time`. - `modified_on?: string` - `name?: string` A unique name to identify the event. Only alphanumeric characters, hyphens and underscores are allowed. - `new_users_per_minute?: number` - `prequeue_start_time?: string | null` An ISO 8601 timestamp that marks when to begin queueing all users before the event starts. The prequeue must start at least five minutes before `event_start_time`. - `queueing_method?: string` - `session_duration?: number` - `shuffle_at_event_start?: boolean` If enabled, users in the prequeue will be shuffled randomly at the `event_start_time`. Requires that `prequeue_start_time` is not null. This is useful for situations when many users will join the event prequeue at the same time and you want to shuffle them to ensure fairness. Naturally, it makes the most sense to enable this feature when the `queueing_method` during the event respects ordering such as **fifo**, or else the shuffling may be unnecessary. - `suspended?: boolean` Suspends or allows an event. If set to `true`, the event is ignored and traffic will be handled based on the waiting room configuration. - `total_active_users?: number` ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const detail = await client.waitingRooms.events.details.get( '699d98642c564d2e855e9661899b7252', '25756b2dfe6e378a06b033b670413757', { zone_id: '023e105f4ecef8ad9ca31a8372d0c353' }, ); console.log(detail.id); ``` #### Response ```json { "result": { "id": "25756b2dfe6e378a06b033b670413757", "created_on": "2014-01-01T05:20:00.12345Z", "custom_page_html": "{{#waitTimeKnown}} {{waitTime}} mins {{/waitTimeKnown}} {{^waitTimeKnown}} Event is prequeueing / Queue all enabled {{/waitTimeKnown}}", "description": "Production event - DO NOT MODIFY", "disable_session_renewal": false, "event_end_time": "2021-09-28T17:00:00.000Z", "event_start_time": "2021-09-28T15:30:00.000Z", "modified_on": "2014-01-01T05:20:00.12345Z", "name": "production_webinar_event", "new_users_per_minute": 0, "prequeue_start_time": "2021-09-28T15:00:00.000Z", "queueing_method": "random", "session_duration": 0, "shuffle_at_event_start": true, "suspended": true, "total_active_users": 0 } } ``` ## Domain Types ### Event Query - `EventQuery` - `event_end_time: string` An ISO 8601 timestamp that marks the end of the event. - `event_start_time: string` An ISO 8601 timestamp that marks the start of the event. At this time, queued users will be processed with the event's configuration. The start time must be at least one minute before `event_end_time`. - `name: string` A unique name to identify the event. Only alphanumeric characters, hyphens and underscores are allowed. - `custom_page_html?: string | null` If set, the event will override the waiting room's `custom_page_html` property while it is active. If null, the event will inherit it. - `description?: string` A note that you can use to add more details about the event. - `disable_session_renewal?: boolean | null` If set, the event will override the waiting room's `disable_session_renewal` property while it is active. If null, the event will inherit it. - `new_users_per_minute?: number | null` If set, the event will override the waiting room's `new_users_per_minute` property while it is active. If null, the event will inherit it. This can only be set if the event's `total_active_users` property is also set. - `prequeue_start_time?: string | null` An ISO 8601 timestamp that marks when to begin queueing all users before the event starts. The prequeue must start at least five minutes before `event_start_time`. - `queueing_method?: string | null` If set, the event will override the waiting room's `queueing_method` property while it is active. If null, the event will inherit it. - `session_duration?: number | null` If set, the event will override the waiting room's `session_duration` property while it is active. If null, the event will inherit it. - `shuffle_at_event_start?: boolean` If enabled, users in the prequeue will be shuffled randomly at the `event_start_time`. Requires that `prequeue_start_time` is not null. This is useful for situations when many users will join the event prequeue at the same time and you want to shuffle them to ensure fairness. Naturally, it makes the most sense to enable this feature when the `queueing_method` during the event respects ordering such as **fifo**, or else the shuffling may be unnecessary. - `suspended?: boolean` Suspends or allows an event. If set to `true`, the event is ignored and traffic will be handled based on the waiting room configuration. - `total_active_users?: number | null` If set, the event will override the waiting room's `total_active_users` property while it is active. If null, the event will inherit it. This can only be set if the event's `new_users_per_minute` property is also set. - `turnstile_action?: "log" | "infinite_queue" | null` If set, the event will override the waiting room's `turnstile_action` property while it is active. If null, the event will inherit it. - `"log"` - `"infinite_queue"` - `turnstile_mode?: "off" | "invisible" | "visible_non_interactive" | "visible_managed" | null` If set, the event will override the waiting room's `turnstile_mode` property while it is active. If null, the event will inherit it. - `"off"` - `"invisible"` - `"visible_non_interactive"` - `"visible_managed"` ### Detail Get Response - `DetailGetResponse` - `id?: string` - `created_on?: string` - `custom_page_html?: string` - `description?: string` A note that you can use to add more details about the event. - `disable_session_renewal?: boolean` - `event_end_time?: string` An ISO 8601 timestamp that marks the end of the event. - `event_start_time?: string` An ISO 8601 timestamp that marks the start of the event. At this time, queued users will be processed with the event's configuration. The start time must be at least one minute before `event_end_time`. - `modified_on?: string` - `name?: string` A unique name to identify the event. Only alphanumeric characters, hyphens and underscores are allowed. - `new_users_per_minute?: number` - `prequeue_start_time?: string | null` An ISO 8601 timestamp that marks when to begin queueing all users before the event starts. The prequeue must start at least five minutes before `event_start_time`. - `queueing_method?: string` - `session_duration?: number` - `shuffle_at_event_start?: boolean` If enabled, users in the prequeue will be shuffled randomly at the `event_start_time`. Requires that `prequeue_start_time` is not null. This is useful for situations when many users will join the event prequeue at the same time and you want to shuffle them to ensure fairness. Naturally, it makes the most sense to enable this feature when the `queueing_method` during the event respects ordering such as **fifo**, or else the shuffling may be unnecessary. - `suspended?: boolean` Suspends or allows an event. If set to `true`, the event is ignored and traffic will be handled based on the waiting room configuration. - `total_active_users?: number`